<?php

namespace Dpd\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TerminateShipmentRequest StructType
 * @subpackage Structs
 */
class TerminateShipmentRequest extends ShipmentRequestBcBase
{
    /**
     * The Reason
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $Reason;
    /**
     * Constructor method for TerminateShipmentRequest
     * @uses TerminateShipmentRequest::setReason()
     * @param string $reason
     */
    public function __construct($reason = null)
    {
        $this
            ->setReason($reason);
    }
    /**
     * Get Reason value
     * @return string
     */
    public function getReason()
    {
        return $this->Reason;
    }
    /**
     * Set Reason value
     * @uses \Dpd\EnumType\EnumReason::valueIsValid()
     * @uses \Dpd\EnumType\EnumReason::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $reason
     * @return \Dpd\StructType\TerminateShipmentRequest
     */
    public function setReason($reason = null)
    {
        // validation for constraint: enumeration
        if (!\Dpd\EnumType\EnumReason::valueIsValid($reason)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Dpd\EnumType\EnumReason', is_array($reason) ? implode(', ', $reason) : var_export($reason, true), implode(', ', \Dpd\EnumType\EnumReason::getValidValues())), __LINE__);
        }
        $this->Reason = $reason;
        return $this;
    }
}
